


--------------------------------------------------------------------------------------------------------------------------------
-- step 1: create unknown serialid regular table
--------------------------------------------------------------------------------------------------------------------------------

if exists (select name from sysobjects
   where name='pdalogs_regular_unknown_temp' and type='U')
   drop table pdalogs_regular_unknown_temp

select cc.serialid, cc.startyear, cc.startmonth, cc.endyear, cc.endmonth, aa.total_mb 
into pdalogs_regular_unknown_temp
from 
-- this is to make sure all sim-bill_period will appear
	(
		select serialid, startyear, startmonth, endyear, endmonth, 0 as total_mb
		from orange_billing_period_view, unknown_serialid_view
	) cc
	left outer join
	(
		select serialid,startyear, startmonth, endyear, endmonth, sum(upload+download)/1024/1024 as total_mb
		from orange_billing_period_view b,pdalogs a
		where
		(
			dateadd(hour, -5, starttime)  >= 
			convert(datetime,			
				convert(char(4),startyear)  +'-'+
				convert(char(4),startmonth) +'-'+
				convert(char(4),startday)			
			    )
		and 
			dateadd(hour, -5, starttime)<=
			convert(datetime,			
				convert(char(4),endyear)  +'-'+
				convert(char(4),endmonth) +'-'+
				convert(char(4),endday)			
				
			    )
		)		
		group by serialid, startyear, startmonth,startday,endyear, endmonth,endday		
		
	) aa
on 
	cc.startyear=aa.startyear 
   	and cc.startmonth=aa.startmonth  
	and cc.endyear=aa.endyear 
	and cc.endmonth=aa.endmonth 
	and cc.serialid=aa.serialid collate database_default



--------------------------------------------------------------------------------------------------------------------------------
-- step 2: make sure there is no null value
--------------------------------------------------------------------------------------------------------------------------------


update pdalogs_regular_unknown_temp 
set total_mb=0.0
where total_mb is null


--------------------------------------------------------------------------------------------------------------------------------
-- step 3: calculate increasing percentage
--------------------------------------------------------------------------------------------------------------------------------
if exists (select name from sysobjects
   where name='pdalogs_regular_unknown_percent_temp' and type='U')
   drop table pdalogs_regular_unknown_percent_temp



select aa.serialid, aa.startyear, aa.startmonth, bb.total_mb, thisMonthIncrease
into pdalogs_regular_unknown_percent_temp
from
pdalogs_regular_unknown_temp bb,

(

	select 
		a.serialid, a.startyear, a.startmonth,(a.total_mb-b.total_mb)/b.total_mb as thisMonthIncrease
	from 
		pdalogs_regular_unknown_temp a, pdalogs_regular_unknown_temp b
	where 
		a.serialid =b.serialid 
		and 
		(
			(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
			or
			(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
		)
		and
		b.total_mb is not null
		and b.total_mb<>0.0 

union

	select distinct serialid, 2007 as startyear, 9 as startmonth, 1.0 as thisMonthIncrease
	from pdalogs_regular_unknown_temp 
	
	where startyear=2007 and startmonth=9
	
	union
	
	select a.serialid, a.startyear, a.startmonth,0.0 as thisMonthIncrease
	from pdalogs_regular_unknown_temp a, pdalogs_regular_unknown_temp b
	where a.serialid =b.serialid 
	and 
	(
		(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
		or
		(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
	)
	
	and b.total_mb=0.0  and a.total_mb=0.0

union

	select a.serialid, a.startyear, a.startmonth,1.0 as thisMonthIncrease
	from
		pdalogs_regular_unknown_temp a, pdalogs_regular_unknown_temp b
	where a.serialid =b.serialid 
	and 
	(
		(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
		or
		(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
	)
	
	and b.total_mb=0.0  and a.total_mb<>0.0
	
) aa

where aa.serialid =bb.serialid and aa.startyear=bb.startyear and aa.startmonth= bb.startmonth







--------------------------------------------------------------------------------------------------------------------------------
-- The following known  regular table is for demo and testing purpose!!!
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
-- The following known serialid regular table is for demo and testing purpose!!!
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
-- The following known serialid regular table is for demo and testing purpose!!!
--------------------------------------------------------------------------------------------------------------------------------



--------------------------------------------------------------------------------------------------------------------------------
-- step 1: create known serialid regular table
--------------------------------------------------------------------------------------------------------------------------------

if exists (select name from sysobjects
   where name='pdalogs_regular_known_temp' and type='U')
   drop table pdalogs_regular_known_temp

select cc.serialid, cc.startyear, cc.startmonth, cc.endyear, cc.endmonth, aa.total_mb 
into pdalogs_regular_known_temp
from 
-- this is to make sure all sim-bill_period will appear
	(
		select serialid, startyear, startmonth, endyear, endmonth
		from orange_billing_period_view, known_serialid_view
	) cc
	left outer join
	(
		select serialid, startyear, startmonth, endyear, endmonth, sum(upload+download)/1024/1024 as total_mb
		from orange_billing_period_view b,pdalogs a
		where
		(
			dateadd(hour, -5, starttime) >= 
			convert(datetime,			
				convert(char(4),startyear)  +'-'+
				convert(char(4),startmonth) +'-'+
				convert(char(4),startday)			
			    )
		and 
			dateadd(hour, -5, starttime)<=
			convert(datetime,			
				convert(char(4),endyear)  +'-'+
				convert(char(4),endmonth) +'-'+
				convert(char(4),endday)			
				
			    )
		)		
		
		group by serialid, startyear, startmonth,startday,endyear, endmonth,endday
		
		--order by sim, startyear, startmonth, endyear, endmonth
	) aa
on cc.startyear=aa.startyear and cc.startmonth=aa.startmonth and cc.endyear=aa.endyear
and cc.endmonth=aa.endmonth and cc.serialid=aa.serialid collate database_default 



--------------------------------------------------------------------------------------------------------------------------------
-- step 2: make sure there is no null value
--------------------------------------------------------------------------------------------------------------------------------

update pdalogs_regular_known_temp 
set total_mb=0.0
where total_mb is null

--------------------------------------------------------------------------------------------------------------------------------
-- step 3: calculate increasing percentage
--------------------------------------------------------------------------------------------------------------------------------
if exists (select name from sysobjects
   where name='pdalogs_regular_known_percent_temp' and type='U')
   drop table pdalogs_regular_known_percent_temp



select aa.serialid, aa.startyear, aa.startmonth, bb.total_mb, thisMonthIncrease
into pdalogs_regular_known_percent_temp
from
pdalogs_regular_known_temp bb,

(

	select 
		a.serialid, a.startyear, a.startmonth,(a.total_mb-b.total_mb)/b.total_mb as thisMonthIncrease
	from 
		pdalogs_regular_known_temp a, pdalogs_regular_known_temp b
	where 
		a.serialid =b.serialid 
		and 
		(
			(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
			or
			(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
		)
		and
		b.total_mb is not null
		and b.total_mb<>0.0 

union

	select distinct serialid, 2007 as startyear, 9 as startmonth, 1.0 as thisMonthIncrease
	from pdalogs_regular_known_temp 
	
	where startyear=2007 and startmonth=9
	
	union
	
	select a.serialid, a.startyear, a.startmonth,0.0 as thisMonthIncrease
	from pdalogs_regular_known_temp a, pdalogs_regular_known_temp b
	where a.SERIALID =b.serialid 
	and 
	(
		(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
		or
		(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
	)
	
	and b.total_mb=0.0  and a.total_mb=0.0

union

	select a.serialid, a.startyear, a.startmonth,1.0 as thisMonthIncrease
	from
		pdalogs_regular_known_temp a, pdalogs_regular_known_temp b
	where a.serialid =b.serialid 
	and 
	(
		(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
		or
		(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
	)
	
	and b.total_mb=0.0  and a.total_mb<>0.0
	
) aa

where aa.serialid =bb.serialid and aa.startyear=bb.startyear and aa.startmonth= bb.startmonth





--do NOT run it, cuz it takes too long!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-----------------------------------------------------------------------------------------------------------------------------
/*
select serialid, startyear, startmonth, sum(upload+download)/1024/1024 as total_mb 
into unknown_serialid_billing_period_sum_temp
from pdalogs a, orange_billing_period_view b
where a.serialid collate database_default in 
(select serialid from unknown_serialid_view_temp)
and    
(
	(datepart(year, dateadd(hour, -5, starttime))>=startyear)
	and
	(datepart(month, dateadd(hour, -5, starttime))>=startmonth) 
	and  
	(datepart(year, dateadd(hour, -5, starttime))<=endyear)
	and
	(datepart(month, dateadd(hour, -5, starttime))<=endmonth)
)

group by serialid, startyear, startmonth

select aa.serialid, aa.startyear, aa.startmonth, bb.total_mb
into unknown_serialid_billing_period_sum_full_temp
from
(select * from
(select distinct serialid from unknown_serialid_billing_period_sum_temp) a,
orange_billing_period_view b) aa
left outer join
unknown_serialid_billing_period_sum_temp bb
on aa.serialid=bb.serialid and aa.startyear=bb.startyear and aa.startmonth=bb.startmonth


update unknown_serialid_billing_period_sum_full_temp
set total_mb=0.0
where total_mb is null
*/
-----------------------------------------------------------------------------------------------------------------------------
/*
select * from unknown_serialid_billing_period_sum_full_temp a
left outer join 
unknown_serialid_billing_period_sum_temp b
on a.serialid=b.serialid and a.startyear=b.startyear and a.startmonth=b.startmonth
order by a.serialid, a.startyear, a.startmonth
*/

/*

select aa.serialid, aa.startyear, aa.startmonth, bb.total_mb, thisMonthIncrease
into unknown_serialid_billing_period_increase_full_temp
from
unknown_serialid_billing_period_sum_full_temp bb,
(
select a.serialid, a.startyear, a.startmonth,(a.total_mb-b.total_mb)/b.total_mb as thisMonthIncrease
from unknown_serialid_billing_period_sum_full_temp a,
unknown_serialid_billing_period_sum_full_temp b
where a.serialid =b.serialid 
and 
(
	(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
	or
	(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
)

and b.total_mb<>0.0 

union

select distinct serialid, 2007 as startyear, 9 as startmonth, 1.0 as thisMonthIncrease
from unknown_serialid_billing_period_sum_full_temp 


union

select a.serialid, a.startyear, a.startmonth,0.0 as thisMonthIncrease
from unknown_serialid_billing_period_sum_full_temp a,
unknown_serialid_billing_period_sum_full_temp b
where a.serialid =b.serialid 
and 
(
	(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
	or
	(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
)

and b.total_mb=0.0  and a.total_mb=0.0

union

select a.serialid, a.startyear, a.startmonth,1.0 as thisMonthIncrease
from unknown_serialid_billing_period_sum_full_temp a,
unknown_serialid_billing_period_sum_full_temp b
where a.serialid =b.serialid 
and 
(
	(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
	or
	(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
)

and b.total_mb=0.0  and a.total_mb<>0.0

) aa

where aa.serialid =bb.serialid and aa.startyear=bb.startyear and aa.startmonth= bb.startmonth
*/

----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------

/*
select serialid, startyear, startmonth, sum(upload+download)/1024/1024 as total_mb 
into known_serialid_billing_period_sum_view_temp
from pdalogs a, orange_billing_period_view b
where a.serialid collate database_default in 
(select serialid from known_sim_serialid_view_temp)
and    
(
	(datepart(year, dateadd(hour, -5, starttime))>=startyear)
	and
	(datepart(month, dateadd(hour, -5, starttime))>=startmonth) 
	and  
	(datepart(year, dateadd(hour, -5, starttime))<=endyear)
	and
	(datepart(month, dateadd(hour, -5, starttime))<=endmonth)
)

group by serialid, startyear, startmonth
*/
----------------------------------------------------------------------------------------------------

/*
--make it regular by adding 0 for missing field
drop table known_serialid_billing_period_sum_full_temp

select a.serialid, a.startyear, a.startmonth, b.total_mb 
into known_serialid_billing_period_sum_full_temp
from 
(
	select serialid, startyear, startmonth 
	from
	(select distinct serialid from known_serialid_billing_period_sum_view_temp) abc,
	orange_billing_period_view 
) a
left outer join
known_serialid_billing_period_sum_view_temp b
on a.serialid=b.serialid and a.startyear=b.startyear and a.startmonth=b.startmonth

-- and now update null field with 0
update known_serialid_billing_period_sum_full_temp
set total_mb=0 where total_mb is null

*/


--order by serialid, startyear, startmonth
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------
--now to make the percentage increase

----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
/*
select aa.serialid, aa.startyear, aa.startmonth, bb.total_mb, thisMonthIncrease
into known_serialid_billing_period_percent_increase_full_temp
from
known_serialid_billing_period_sum_full_temp bb,
(
select a.serialid, a.startyear, a.startmonth,(a.total_mb-b.total_mb)/b.total_mb as thisMonthIncrease
from known_serialid_billing_period_sum_full_temp a,
known_serialid_billing_period_sum_full_temp b
where a.serialid =b.serialid 
and 
(
	(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
	or
	(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
)

and b.total_mb<>0.0 

union

select distinct serialid, 2007 as startyear, 9 as startmonth, 1.0 as thisMonthIncrease
from known_serialid_billing_period_sum_full_temp 

union

select a.serialid, a.startyear, a.startmonth,0.0 as thisMonthIncrease
from known_serialid_billing_period_sum_full_temp a,
known_serialid_billing_period_sum_full_temp b
where a.serialid =b.serialid 
and 
(
	(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
	or
	(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
)

and b.total_mb=0.0  and a.total_mb=0.0

union

select a.serialid, a.startyear, a.startmonth,1.0 as thisMonthIncrease
from known_serialid_billing_period_sum_full_temp a,
known_serialid_billing_period_sum_full_temp b
where a.serialid =b.serialid 
and 
(
	(a.startyear=b.startyear and a.startmonth=b.startmonth+1)
	or
	(a.startyear=b.startyear+1 and a.startmonth+11=b.startmonth)
)

and b.total_mb=0.0  and a.total_mb<>0.0

) aa

where aa.serialid =bb.serialid and aa.startyear=bb.startyear and aa.startmonth= bb.startmonth
*/
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------

--select * from orangebills_regular order by sim, startyear, startmonth

--select * from known_sim_serialid_view_temp where sim = '8944121144208088709'

--select * from orangebills_known_sim_regular 

--drop table orangebills_regular
--select * into orangebills_regular from orangebills_regular_backup 


