use datawind
if exists (select name from sysobjects
   where name='find_sim_proc' and type='P')
   drop procedure find_sim_proc

go 
use datawind
go


CREATE PROCEDURE find_sim_proc
@sim  varchar(255),
@tolerance float


as

select aa.sim, aa.serialid as candidate, aa.counting, bb.serialid as true_serialid
from
(
select a.sim, b.serialid,  count(a.sim)as counting
--a.thismonthincrease as bill_increase, b.thismonthIncrease as log_increase
from orangebills_regular_percent_temp  a,

unknown_serialid_billing_period_increase_full_view_temp b
where
a.sim = @sim and
a.startyear=b.startyear and a.startmonth=b.startmonth
and
(
	(((a.thisMonthIncrease + @tolerance)>0.0) and ((b.thisMonthIncrease +@tolerance)>0.0))
	or 
	(
		(((a.thisMonthIncrease+@tolerance)>=0.0) and ((a.thisMonthIncrease-@tolerance)<=0.0)) 
		 and 
		(((b.thisMonthIncrease+@tolerance)>=0.0) and ((b.thisMonthIncrease-@tolerance)<=0.0)) 
	)
	or 
	(((a.thisMonthIncrease- @tolerance)<0.0) and ((b.thisMonthIncrease-@tolerance)<0.0))
)

group by a.sim, b.serialid

having count(a.sim)>10
) aa
left outer join
known_sim_serialid_view_temp bb
on aa.sim=bb.sim

order by counting desc


